package com.example.tdl.config;

import com.example.tdl.interceptor.LoginInterceptor;
import com.example.tdl.interceptor.PermissionInterceptor;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;

@Configuration
public class MyWebMvcConfigurer extends WebMvcConfigurerAdapter {

    @Bean
    public LoginInterceptor loginInterceptor(){
        return new LoginInterceptor();
    }

    @Bean
    public PermissionInterceptor permissionInterceptor(){
        return new PermissionInterceptor();
    }

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(loginInterceptor())
                .excludePathPatterns("/alarmLog/addAlarmLog")
                    .excludePathPatterns("/login/**")
                .excludePathPatterns("/getData");
        registry.addInterceptor(permissionInterceptor())
                .excludePathPatterns("/login/**")
                .excludePathPatterns("/alarmLog/addAlarmLog")
                .excludePathPatterns("/side/**")
                .excludePathPatterns("/downLoad")
                .excludePathPatterns("/getAddress")
        .excludePathPatterns("/test")
        .excludePathPatterns("/getData");
        super.addInterceptors(registry);
    }


}
