package com.example.tdl.mapper;

import com.example.tdl.domain.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface CircuitMapper {
    List<CircuitResultVo> getAll(@Param("companyNo") String companyNo,@Param("page") Integer page,@Param("rows") Integer rows);

    Integer getAllCount(@Param("companyNo") String companyNo);

    Integer getByTermCount(CircuitTermVo circuitTermVo);

    List<CircuitResultVo> getByTerm(@Param("circuitTermVo") CircuitTermVo circuitTermVo,@Param("page") Integer page,@Param("rows") Integer rows);

    int addCircuit(Map<Object,Object> map);

    int add(Map<Object,Object> map);

    int endCircuit(Map<Object,Object> map);

    int updateCircuit(Map<Object,Object> map);

    int updateEndTime(UpdateCircuitVo updateCircuitVo);

    int updateStartTime(Map<Object,Object> map);

    int delCircuit(String transportationNo);

    int deleteCircuit(Map<Object,Object> map);

    ResultCircuitVo getByTransportationNo(@Param("transportationNo") String transportationNo,@Param("companyNo") String companyNo);

    Integer getOnRoute(@Param("companyNo") String companyNo);

    Integer getDelayCount(@Param("compTime") Long compTime, @Param("time") String time,@Param("companyNo") String companyNo);

    Integer getDelay(@Param("compTime")Long compTime,@Param("companyNo") String companyNo);

    Integer getCount(@Param("time") String time,@Param("endTime") Long endTime,@Param("companyNo") String companyNo);

    List<AppCircuitVo> getByPlateNo(@Param("plateNo") String plateNo,@Param("companyNo") String companyNo);

    ResultCircuitForAppVo getByTransportationNoForApp(@Param("transportationNo") String transportationNo,@Param("companyNo") String companyNo);

    ResultCircuitVo  getCircuit(String transportationNo);

    List<AppCircuitVo> getByCircuitState(@Param("circuitState") Integer circuitState,@Param("companyNo") String companyNo);

    int updateEvaluate(UpdateEvaluateVo updateEvaluateVo);

    Integer getNo(String transportationNo);

    ResultGatewayVo getByNo(String transportationNo);

    List<ResultCircuitVo> getByTime(String companyNo);

    CircuitMessage getMessage(String transportationNo);

    String getStartCity(String transportationNo);

    String getEndCity(String transportationNo);

}
