package com.example.tdl.mapper;

import com.example.tdl.domain.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface TDLLogMapper {

    ResultGatewayVo getByNo(String transportationNo);

    TDLLogVo getByTransportationNo(String transportationNo);

    List<String> getTdlSN(String transportationNo);

    String getSN(String transportationNo);

    List<String> getByAlarm(DelAlarmVo delAlarmVo);

    ResultAlarmVo getByTdl(@Param("transportationNo") String transportationNo, @Param("TDLSN") String TDLSN);

    ResultAlarmVo getWarehouseByTdl(@Param("warehouseNo") String warehouseNo, @Param("TDLSN") String TDLSN);

    ResultAlarmVo getAlarm(@Param("gatewaySN")String gatewaySN,@Param("gatewayType")String gatewayType,@Param("TDLSN")String TdlSN);

    List<WarehouseLogVo> getByWarehouse(String warehouseNo);

    Long getTimeByWarehouseNo(@Param("warehouseNo")String warehouseNo,@Param("gatewaySN")String gatewaySN);

    List<ResultWarehouseNoAndTDLSNAndTimeVo> getByWarehouseNoAndTime(DownloadForWarehouseVo downloadForWarehouseVo);

}
