package com.example.tdl.mapper;


import com.example.tdl.domain.vo.*;
import com.example.tdl.entity.Warehouse;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.PostMapping;

import java.util.List;
import java.util.Map;


@Mapper
public interface WarehouseMapper {
    List<ResultWarehouseVo> getAll(String companyNo);

    List<ResultWarehouseVo> getAllWarehouse();

    List<ResultWarehouseVo> getAllByTerm(WarehouseTermVo warehouseTermVo);

    List<SimpleWarehouseVo> getByWarehouse(WareHouseByTermVo wareHouseByTermVo);

    List<DeviceVo> getDevice(String  warehouseNo);

    Integer  getWarehouseNo(@Param("warehouseNo")String warehouseNo,@Param("companyNo")String  companyNo);

    Integer getByWarehouseNoAndSN(@Param("warehouseNo") String warehouseNo,@Param("SN") String SN);

    int addWarehouse(Map<Object,Object> map);

    int updateWarehouse(Map<Object,Object> map);

    int delWarehouse(Map<Object,Object> map);

    int addGateway(Map<Object,Object> map);

    int untieGateway(Map<Object,Object> map);

    int addUser(Map<Object,Object> map);

    List<AlarmContactsVo> getAlarmContacts(String  warehouseNo);

    ResultWarehouseVo getByWarehouseName(@Param("warehouseName") String warehouseName, @Param("companyNo") String companyNo);

    List<ResultWarehouseVo> getByAlarm(DelAlarmVo delAlarmVo);

    List<GatewaySNVo> getGateway(String warehouseNo);

    Integer updateImg(@Param("warehouseNo")String warehouseNo,@Param("img")String img,@Param("updateTime") Long  updateTime);

    WarehouseDetailVo getWarehouseDetailByNo(@Param("warehouseNo") String warehouseNo);

    DeviceMessageVo  getDeviceMessage(SearchTdlVo searchTdlVo);

    List<WarehouseNameVo> getWarehouseName(@Param("warehouseName") String warehouseName,@Param("companyNo") String companyNo );

    List<String> getEmailByWarehouse(String warehouseNo);
}
