package com.example.tdl.service;


import com.example.tdl.domain.vo.*;
import com.example.tdl.mapper.CircuitMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class CircuitService {
    @Autowired
    private CircuitMapper circuitMapper;

    public List<CircuitResultVo> getAll(String companyNo,Integer page,Integer rows){
        return circuitMapper.getAll(companyNo,page,rows);
    }

    public Integer getAllCount(String companyNo){
        return circuitMapper.getAllCount(companyNo);
    }

    public List<CircuitResultVo> getByTerm(CircuitTermVo circuitTermVo,Integer page,Integer rows){
        return circuitMapper.getByTerm(circuitTermVo,page,rows);
    }

    public Integer getByTermCount(CircuitTermVo circuitTermVo){
        return circuitMapper.getByTermCount(circuitTermVo);
    }

    public int addCircuit(Map<Object,Object> map){
        return circuitMapper.addCircuit(map);
    }

    public int add(Map<Object,Object> map){
        return circuitMapper.add(map);
    }

    public int endCircuit(Map<Object,Object> map){
        return circuitMapper.endCircuit(map);
    }

    public int updateCircuit(Map<Object,Object> map){
        return circuitMapper.updateCircuit(map);
    }


    public int updateEndTime(UpdateCircuitVo updateCircuitVo){
        return circuitMapper.updateEndTime(updateCircuitVo);
    }

    public int updateStartTime(Map<Object,Object> map){
        return circuitMapper.updateStartTime(map);
    }

    public int delCircuit(String transportationNo){
        return circuitMapper.delCircuit(transportationNo);
    }

    public int deleteCircuit(Map<Object,Object> map){
        return circuitMapper.deleteCircuit(map);
    }


    public ResultCircuitVo getByTransportationNo(String transportationNo,String companyNo){
        return circuitMapper.getByTransportationNo(transportationNo,companyNo);
    }

    public ResultCircuitForAppVo getByTransportationNoForApp(String transportationNo,String companyNo){
        return circuitMapper.getByTransportationNoForApp(transportationNo,companyNo);
    }

    public  ResultCircuitVo  getCircuit(String transportationNo){
        return circuitMapper.getCircuit(transportationNo);
    }

    public Integer getOnRoute(String companyNo){
        return circuitMapper.getOnRoute(companyNo);
    }

    public Integer getDelayCount(Long compTime,String time,String companyNo){
        return circuitMapper.getDelayCount(compTime,time,companyNo);
    }

    public Integer getDelay(Long compTime,String companyNo){
        return circuitMapper.getDelay(compTime,companyNo);
    }

    public Integer getCount(String time,Long startTime,String companyNo){
        return circuitMapper.getCount(time,startTime,companyNo);
    }

    public List<AppCircuitVo> getByPlateNo(String plateNo,String companyNo){
        return circuitMapper.getByPlateNo(plateNo,companyNo);
    }

    public List<AppCircuitVo> getByCircuitState(Integer circuitState,String companyNo){
        return circuitMapper.getByCircuitState(circuitState,companyNo);
    }

    public int updateEvaluate(UpdateEvaluateVo updateEvaluateVo){
        return circuitMapper.updateEvaluate(updateEvaluateVo);
    }

    public Integer getNo(String transportationNo){
            return circuitMapper.getNo(transportationNo);
    }

    public ResultGatewayVo getByNo(String transportationNo){
        return circuitMapper.getByNo(transportationNo);
    }

    public List<ResultCircuitVo> getByTime(String companyNo){
        return circuitMapper.getByTime(companyNo);
    }


    public CircuitMessage getMessage(String transportationNo){
        return circuitMapper.getMessage(transportationNo);
    }

//    public List<CircuitVo> getDistinct(){
//        return circuitMapper.getDistinct();
//    }


//    public Integer getComplted(String time){
//        return circuitMapper.getComplted(time);
//    }

}
