package com.example.tdl.service;


import com.example.tdl.domain.vo.*;
import com.example.tdl.mapper.GatewayMapper;
import com.example.tdl.mapper.RoleMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class GatewayService {
    @Autowired
    private GatewayMapper gatewayMapper;

    public List<ResultGatewayVo> getAll(String companyNo){
        return gatewayMapper.getAll(companyNo);
    }

    public String getBySN(String SN,String companyNo){
        return gatewayMapper.getBySN(SN,companyNo);
    }

    public int addGateway(Map<Object,Object> map){
        return gatewayMapper.addGateway(map);
    }

    public int updateGateway(UpdateGatewayVo updateGatewayVo){
        return gatewayMapper.updateGateway(updateGatewayVo);
    }

    public int delGateway(Map<Object,Object> map){
        return gatewayMapper.delGateway(map);
    }

    public ResultGatewayVo getBySNAndType(String SN,String type){
        return gatewayMapper.getBySNAndType(SN,type);
    }

    public int getIdBySNAndType(String SN,String type,String companyNo){
        return gatewayMapper.getIdBySNAndType(SN,type,companyNo);
    }

    public int deployGateway(Map<Object,Object> map){
        return gatewayMapper.deployGateway(map);
    }

    public Boolean updateState(GatewayState gatewayState){
        return gatewayMapper.updateState(gatewayState)==1;
    }

    public String getTransportationNo(String SN,String type){
        return gatewayMapper.getTransportationNo(SN,type);
    }

    public String getWarehouseNo(String SN,String type){
        return gatewayMapper.getWarehouseNo(SN,type);
    }

    public  List<GatewaySNVo> getUnusedGateway(String SN,String companyNo){
        return  gatewayMapper.getUnusedGateway(SN,companyNo);
    }

    public int updateCompany(UpdateGatewayCompanyVo updateGatewayCompanyVo){
        return gatewayMapper.updateCompany(updateGatewayCompanyVo);
    }

    public List<GatewayOnLineVo> getByWarehouseNo(String warehouseNo){
        return gatewayMapper.getByWarehouseNo(warehouseNo);
    }


    public List<TypeVo> getGatewayType(String companyNo){
        return gatewayMapper.getGatewayType(companyNo);
    }
}
