package com.example.tdl.service;


import com.example.tdl.domain.vo.*;
import com.example.tdl.entity.Warehouse;
import com.example.tdl.mapper.WarehouseMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class WarehouseService {
    @Autowired
    private WarehouseMapper warehouseMapper;

    public List<ResultWarehouseVo> getAll(String  companyNo){
        return warehouseMapper.getAll(companyNo);
    }

    public List<ResultWarehouseVo> getAllWarehouse(){
        return warehouseMapper.getAllWarehouse();
    }


    public List<ResultWarehouseVo> getAllByTerm(WarehouseTermVo warehouseTermVo){
        return warehouseMapper.getAllByTerm(warehouseTermVo);
    }

    public List<SimpleWarehouseVo> getByWarehouse(WareHouseByTermVo wareHouseByTermVo){
        return warehouseMapper.getByWarehouse(wareHouseByTermVo);
    }

    public List<DeviceVo> getDevice(String  warehouseNo){
        return warehouseMapper.getDevice(warehouseNo);
    }

    public  Integer  getWarehouseNo(String warehouseNo,String  companyNo){
        return  warehouseMapper.getWarehouseNo(warehouseNo,companyNo);
    }

    public  Integer getByWarehouseNoAndSN(String warehouseNo,String SN){
        return  warehouseMapper.getByWarehouseNoAndSN(warehouseNo,SN);
    }

    public int addWarehouse(Map<Object,Object> map){
        return warehouseMapper.addWarehouse(map);
    }

    public int updateWarehouse(Map<Object,Object> map){
        return warehouseMapper.updateWarehouse(map);
    }

    public int delWarehouse(Map<Object,Object> map){
        return warehouseMapper.delWarehouse(map);
    }

    public int addGateway(Map<Object,Object> map){
        return warehouseMapper.addGateway(map);
    }


    public int untieGateway(Map<Object,Object> map){
        return warehouseMapper.untieGateway(map);
    }

    public int addUser(Map<Object,Object> map){
        return warehouseMapper.addUser(map);
    }

    public List<AlarmContactsVo> getAlarmContacts(String  warehouseNo){
        return warehouseMapper.getAlarmContacts(warehouseNo);
    }

    public ResultWarehouseVo getByWarehouseName(String warehouseName,String companyNo){
        return warehouseMapper.getByWarehouseName(warehouseName,companyNo);
    }

    public List<ResultWarehouseVo> getByAlarm(DelAlarmVo delAlarmVo){
        return warehouseMapper.getByAlarm(delAlarmVo);
    }

    public List<GatewaySNVo> getGateway(String warehouseNo){
        return warehouseMapper.getGateway(warehouseNo);
    }

    public Integer updateImg(String warehouseNo, String img, Long  updateTime){
        return warehouseMapper.updateImg(warehouseNo,img,updateTime);
    }

    public WarehouseDetailVo getWarehouseDetailByNo(String warehouseNo){
        return warehouseMapper.getWarehouseDetailByNo(warehouseNo);
    }

    public  DeviceMessageVo  getDeviceMessage(SearchTdlVo searchTdlVo){
        return warehouseMapper.getDeviceMessage(searchTdlVo);
    }

    public List<WarehouseNameVo> getWarehouseName(String warehouseName,String companyNo ){
        return warehouseMapper.getWarehouseName(warehouseName,companyNo);
    }


    public List<String> getEmailByWarehouse(String warehouseNo){
        return warehouseMapper.getEmailByWarehouse(warehouseNo);
    }
}
