package com.example.tdl.util;

import com.example.tdl.domain.vo.AlarmRuleVo;
import com.example.tdl.domain.vo.ResultAlarmVo;
import com.example.tdl.service.AlarmService;
import com.example.tdl.service.redis.AlarmRedisService;
import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.List;

public class AlarmRule {

    private static  Gson gson = new Gson();

   private static List<String> list = new ArrayList<String>(){{
        add("T");
        add("h");
        add("a1");
        add("ta");
    }};


    public static void saveAlarmRule(String topic, String TDLSN, String alarmType, String companyNo, AlarmService alarmService, AlarmRedisService alarmRedisService){
        ResultAlarmVo alarmVo =  alarmService.getByType(alarmType,companyNo);
        for(String alias :list){
            List<AlarmRuleVo> alarmRuleVos = new ArrayList<>();
            AlarmRuleVo alarmRuleVo = new AlarmRuleVo();
            if(alias.equals("T")){
                alarmRuleVo.setMinval(String.valueOf(alarmVo.getTemMin()));
                alarmRuleVo.setMaxval(String.valueOf(alarmVo.getTemMax()));
                alarmRuleVo.setMode("twoway");
                alarmRuleVo.setPriority("1");
            }else if(alias.equals("h")){
                alarmRuleVo.setMinval(String.valueOf(alarmVo.getHumidityMin()));
                alarmRuleVo.setMaxval(String.valueOf(alarmVo.getHumidityMax()));
                alarmRuleVo.setMode("twoway");
                alarmRuleVo.setPriority("1");
            }else if(alias.equals("ta")){
                alarmRuleVo.setMaxval(String.valueOf(alarmVo.getTilt()));
                alarmRuleVo.setMode("greater");
                alarmRuleVo.setPriority("1");
            }else if(alias.equals("a1")){
                alarmRuleVo.setMaxval(String.valueOf(alarmVo.getShock()));
                alarmRuleVo.setMode("greater");
                alarmRuleVo.setPriority("1");
            }
            alarmRuleVos.add(alarmRuleVo);
            //向redis中写入报警信息
            alarmRedisService.hmSet(topic,"TDL-" +TDLSN+"_" +alias,gson.toJson(alarmRuleVos));
        }
    }
}
